//---------------------------------------------------------------------------
#ifndef kresleniH
#define kresleniH
//---------------------------------------------------------------------------
#include <stdio.h>
#include <mgl.h>
//---------------------------------------------------------------------------

extern int obrx, obry,
           virtx, virty;

#define VX(a) a*virtx/obrx
#define VY(a) a*virty/obry

class TElement {

  public:
    virtual void Zobraz() = 0;
    virtual void Save(FILE *soubor) = 0;
    virtual int GetTyp() = 0;
};

class TElementBod: public TElement {
  int x, y;
  mglColor barva;
  float sirka;

  public:
    TElementBod(int ax, int ay, mglColor abarva);
    virtual void Zobraz();
    virtual void Save(FILE *soubor);
    void GetXY(int &ax, int &ay) { ax = x; ay = y; };
    void SetXY(int ax, int ay) { x = ax; y = ay; };
    int GetTyp() { return 0; };
    float GetSirka() { return sirka; };
    void SetSirka(float asirka) { sirka = asirka; };

    void GetBarva(mglColor abarva[3]) { abarva[0] = barva; };
    void SetBarva(mglColor abarva[3]) { barva = abarva[0]; };
};

class TElementCara: public TElement {
  int x[2], y[2];
  mglColor barva[2];
  float sirka;

  public:
    TElementCara(int ax[3], int ay[3], mglColor abarva[3]);
    virtual void Zobraz();
    virtual void Save(FILE *soubor);

    void GetXY1(int &ax, int &ay) { ax = x[0]; ay = y[0]; };
    void SetXY1(int ax, int ay) { x[0] = ax; y[0] = ay; };
    void GetXY2(int &ax, int &ay) { ax = x[1]; ay = y[1]; };
    void SetXY2(int ax, int ay) { x[1] = ax; y[1] = ay; };
    int GetTyp() { return 1; };
    float GetSirka() { return sirka; };
    void SetSirka(float asirka) { sirka = asirka; };
    void GetBarva(mglColor abarva[3]) { abarva[0] = barva[0]; abarva[1] = barva[1]; };
    void SetBarva(mglColor abarva[3]) { barva[0] = abarva[0]; barva[1] = abarva[1]; };
};

class TElementTrojuhelnik: public TElement {
  int x[3], y[3];
  mglColor barva[3];
  bool vyplneny;

  public:
    TElementTrojuhelnik(int ax[3], int ay[3], mglColor abarva[3]);
    virtual void Zobraz();
    virtual void Save(FILE *soubor);

    void GetXY1(int &ax, int &ay) { ax = x[0]; ay = y[0]; };
    void SetXY1(int ax, int ay) { x[0] = ax; y[0] = ay; };
    void GetXY2(int &ax, int &ay) { ax = x[1]; ay = y[1]; };
    void SetXY2(int ax, int ay) { x[1] = ax; y[1] = ay; };
    void GetXY3(int &ax, int &ay) { ax = x[2]; ay = y[2]; };
    void SetXY3(int ax, int ay) { x[2] = ax; y[2] = ay; };
    int GetTyp() { return 2; };
    float GetVyplneny() { return vyplneny; };
    void SetVyplneny(float avyplneny) { vyplneny = avyplneny; };
    void GetBarva(mglColor abarva[3]) { abarva[0] = barva[0]; abarva[1] = barva[1];
                                        abarva[2] = barva[2]; };
    void SetBarva(mglColor abarva[3]) { barva[0] = abarva[0]; barva[1] = abarva[1];
                                        barva[2] = abarva[2]; };
};

class TElementObdelnik: public TElement {
  int x[2], y[2];
  mglColor barva[4];
  bool vyplneny;

  public:
    TElementObdelnik(int ax[3], int ay[3], mglColor abarva[3]);
    virtual void Zobraz();
    virtual void Save(FILE *soubor);

    void GetXY1(int &ax, int &ay) { ax = x[0]; ay = y[0]; };
    void SetXY1(int ax, int ay) { x[0] = ax; y[0] = ay; };
    void GetXY2(int &ax, int &ay) { ax = x[1]; ay = y[1]; };
    void SetXY2(int ax, int ay) { x[1] = ax; y[1] = ay; };
    int GetTyp() { return 3; };
    float GetVyplneny() { return vyplneny; };
    void SetVyplneny(float avyplneny) { vyplneny = avyplneny; };
    void GetBarva(mglColor abarva[3]) { abarva[0] = barva[0]; abarva[1] = barva[1]; };
    void SetBarva(mglColor abarva[3]) { barva[0] = abarva[0]; barva[1] = abarva[1]; };
};

//---------------------------------------------------------------------------
#endif
